package org.gcube.informationsystem.resourceregistry.dbinitialization;

import org.gcube.informationsystem.base.reference.ISConstants;
import org.gcube.informationsystem.resourceregistry.api.exceptions.ResourceRegistryException;
import org.gcube.informationsystem.resourceregistry.instances.context.ContextUtility;
import org.gcube.informationsystem.resourceregistry.security.SecurityContext.PermissionMode;
import org.junit.Assert;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.orientechnologies.orient.core.db.ODatabase.ATTRIBUTES;
import com.orientechnologies.orient.core.db.document.ODatabaseDocument;

public class DatabaseEnvironmentTest {
	
	private static Logger logger = LoggerFactory.getLogger(DatabaseEnvironmentTest.class);
	
	// @Test
	public void createDB() throws Exception{
		String db = DatabaseEnvironment.DB_URI;
		logger.trace("Created DB is {}", db);
	}
	
	@Test
	public void testAlterDateTimeFormat() throws ResourceRegistryException {
		ODatabaseDocument oDatabaseDocument = ContextUtility.getAdminSecurityContext().getDatabaseDocument(PermissionMode.WRITER);
		DatabaseEnvironment.setDateTimeFormat(oDatabaseDocument);
		String dateTime = oDatabaseDocument.get(ATTRIBUTES.DATETIMEFORMAT).toString();
		Assert.assertTrue(dateTime.compareTo(ISConstants.DATETIME_PATTERN)==0);
	}
	
	
	/*
	@Test
	public void generateDBKey() throws Exception {
		Properties properties = new Properties();
		InputStream input = DatabaseEnvironmentTest.class.getClassLoader().getResourceAsStream("config.properties");
			
		// load a properties file
		properties.load(input);
		
		String keyFileName = properties.getProperty("DB_KEY_FILENAME");
		String keyAlgorithm = properties.getProperty("DB_KEY_ALGORITHM_VARNAME");
		
		URL url = SymmetricKey.class.getResource(keyFileName);
		Key key = null;
		if(url!=null) {
			try {
				key = SymmetricKey.loadKeyFromFile(keyFileName, keyAlgorithm);
			} catch(Exception e) {
			
			}
		}
		
		if(key==null){
			key = KeyFactory.newAESKey();
			File file = new File("src/test/resources", keyFileName);
			KeySerialization.store(key, file);
		}
	}
	*/
	
}
